<script setup lang="ts">
    import SActionButton from '@/shared/button/components/SActionButton.vue'
    import SContentContainer from '@/components/layout/SContentContainer.vue'
    import RouteNavigationDrawer from '@/shared/administration/components/RouteNavigationDrawer.vue'
    import SFooter from '@/components/layout/SFooter.vue'
    import { useMsal } from '@/plugins/msal/useMsal'
    import { CarlConfigurationIntervention } from '@/interventionServiceOffer/entities/gmaoConfigurationIntervention/carlConfigurationIntervention/CarlConfigurationIntervention'
    import { CarlConfigurationInterventionApi } from '@/interventionServiceOffer/entities/gmaoConfigurationIntervention/carlConfigurationIntervention/CarlConfigurationInterventionApi'
    import { ref, watch } from 'vue'
    import SListItem from '@/shared/item/components/SListItem.vue'
    import { useUserStore } from '@/shared/user/stores/UserStore'

    const msal = useMsal()
    const userStore = useUserStore(msal)
    const carlConfigurationInterventions = ref<CarlConfigurationIntervention[]>(
        []
    )

    const carlConfigurationInterventionApi =
        new CarlConfigurationInterventionApi(msal)

    const isLoading = ref(false)

    watch(
        [() => msal.accounts, () => userStore.isImpersonating],
        () => {
            isLoading.value = true
            carlConfigurationInterventionApi
                .getAll()
                .then(
                    (returnedCarlConfigurationInterventions) =>
                        (carlConfigurationInterventions.value =
                            returnedCarlConfigurationInterventions)
                )
                .finally(() => (isLoading.value = false))
        },
        { immediate: true }
    )
</script>

<template>
    <route-navigation-drawer page-title="Configuration Carl d'intervention" />
    <v-main>
        <s-content-container>
            <h2 class="pt-3">
                {{ carlConfigurationInterventions.length }} configurations Carl
                d'intervention
            </h2>
            <v-skeleton-loader
                v-if="isLoading"
                type="heading, heading, heading"
            ></v-skeleton-loader>
            <v-list>
                <template
                    v-for="(
                        carlConfigurationIntervention, index
                    ) in carlConfigurationInterventions"
                    :key="carlConfigurationIntervention.id"
                    ><v-divider v-if="index > 0"></v-divider>
                    <s-list-item
                        :item="carlConfigurationIntervention"
                        no-image
                        :to="{
                            name: 'admin/configuration-carl-intervention/modifier',
                            params: { id: carlConfigurationIntervention.id },
                        }"
                        :data-cy="
                            'carl-configuration-intervention-' +
                            carlConfigurationIntervention.title
                                .replace(/ /g, '-')
                                .toLocaleLowerCase()
                        "
                    />
                </template>
            </v-list>

            <s-action-button
                icon="mdi-plus"
                label="configuration"
                data-cy="create-carl-configuration-intervention"
                display="floating-fixed"
                position="right"
                :to="{
                    name: 'admin/configuration-carl-intervention/créer',
                }"
            >
            </s-action-button>
        </s-content-container>
    </v-main>
    <s-footer />
</template>
